/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.contents.text;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Collection;
import kinugasa.contents.resource.ContentsIOException;
import kinugasa.util.annotations.CallSuper;
import kinugasa.util.annotations.CallTiming;
import kinugasa.util.annotations.CastReturnValue;
import kinugasa.util.annotations.VirtualMethod;

/**
 * テキストファイルを発行すためのTextIOの実装です.
 * <br>
 *
 * <br>
 *
 * @param <T> テキストファイルのある1行の内容を表すクラスを指定します。
 *            たとえば、CSVファイルではString[]です。<br>
 *
 * @version 1.0.0 - 2013/01/13_20:20:00<br>
 * @author Dra0211<br>
 */
public class TextWriter<T> extends TextIO<T> {

	private static final long serialVersionUID = 6062888702166716010L;
	/** 型Tを文字列に発行するためのライターです. */
	private Writer<T> writer;

	/**
	 * ファイルとライターを指定して、書き込み用ファイルを構築します.
	 *
	 * @param file   ファイルを指定します。<br>
	 * @param writer 文字列に変換するライターを指定します。<br>
	 */
	public TextWriter(File file, Writer<T> writer) {
		super(file);
		this.writer = writer;
	}

	/**
	 * ファイルパスとライターを指定して、書き込み用ファイルを構築します.
	 *
	 * @param filePath ファイルパスを指定します。<br>
	 * @param writer   文字列に変換するライターを指定します。<br>
	 */
	public TextWriter(String filePath, Writer<T> writer) {
		super(filePath);
		this.writer = writer;
	}

	/**
	 * テキストファイルを発行します.
	 * ファイルが存在しない場合は、新規に作成されます。<br>
	 * すでに存在する場合は上書きされます。<br>
	 *
	 * @throws ContentsIOException ファイルを書き込めない場合に投げられます。<br>
	 */
	public void save() throws ContentsIOException {
		FileWriter fw = null;
		BufferedWriter bw = null;
		try {
			fw = new FileWriter(file);
			bw = new BufferedWriter(fw);
			String line;
			for (T obj : this) {
				line = writer.toString(obj);
				bw.write(line, 0, line.length());
				bw.newLine();
			}
			System.out.println("> TextWriter : save : [" + file.getName() + "] : SAVE COMPLETED : size=[" + size() + "]");
		} catch (java.io.IOException ex) {
			throw new ContentsIOException(ex);
		} finally {
			try {
				if (bw != null) {
					bw.close();
				}
				if (fw != null) {
					fw.close();
				}
			} catch (java.io.IOException ex) {
				throw new ContentsIOException(ex);
			}
		}
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> add(Collection<? extends T> obj) {
		return (TextWriter<T>) super.add(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> add(T obj) {
		return (TextWriter<T>) super.add(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> add(T... obj) {
		return (TextWriter<T>) super.add(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> add(TextIO<? extends T> other) {
		return (TextWriter<T>) super.add(other);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> remove(Collection<? extends T> obj) {
		return (TextWriter<T>) super.remove(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> remove(T obj) {
		return (TextWriter<T>) super.remove(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> remove(T... obj) {
		return (TextWriter<T>) super.remove(obj);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> remove(TextIO<? extends T> other) {
		return (TextWriter<T>) super.remove(other);
	}

	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	@Override
	public TextWriter<T> clear() {
		return (TextWriter<T>) super.clear();
	}

	/**
	 * ライターを取得します.
	 *
	 * @return このテキストファイルを発行するためのライターを返します。<br>
	 */
	public Writer<T> getWriter() {
		return writer;
	}

	/**
	 * ライターを設定します.
	 *
	 * @param writer このテキストファイルを発行するためのライターを設定します。<br>
	 */
	public void setWriter(Writer<T> writer) {
		this.writer = writer;
	}
}
